import { AzureServicePrincipal, Discriminator } from "@octopusdeploy/step-api";

interface CustomFiles {
    type: Discriminator<"custom files">;
    files: Array<{
        glob: string;
        prefixName: string;
        metadata: Map<string, string>;
        tags: Map<string, string>;
    }>;
}

interface EntirePackage {
    type: Discriminator<"entire package">;
    exclusions: string[];
    prefixName: string;
    metadata: Map<string, string>;
    tags: Map<string, string>;
}

interface ObjectWithTrueDiscriminator {
    type: Discriminator<true>;
    foo: "Something";
}

interface ObjectWithFalseDiscriminator {
    type: Discriminator<false>;
    bar: "Other";
}

interface NumberOneDiscriminator {
    type: Discriminator<1>;
    foo: "Something";
}

interface NumberTwoDiscriminator {
    type: Discriminator<2>;
    foo: "Other";
}

type NumberDescrimination = NumberOneDiscriminator | NumberTwoDiscriminator;
type BooleanDiscrimination = ObjectWithTrueDiscriminator | ObjectWithFalseDiscriminator;

type FilesToInclude = EntirePackage | CustomFiles;

export default interface BlobStorageStepInputs {
    // These are contributed by the target/account
    account: AzureServicePrincipal;
    booleanDiscrimination: BooleanDiscrimination;
    numberDiscrimination: NumberDescrimination;
    containerName: string;
    package: { extractedToPath: string };
    accountName: string;
    required: boolean;
    filesToInclude: FilesToInclude;
    override: boolean;
}
